class Case {
    constructor(value, result = null) {
        this.value = value;
        this.result = result;
    }
    case(compareValue, result) {
        if (isPresent(this.result)) {
            return this;
        }
        else if (compareValue === this.value) {
            return handleResultAndGetCase(this.value, result);
        }
        return new Case(this.value);
    }
    default(defaultValue) {
        if (isPresent(this.result)) {
            return this.result;
        }
        return defaultValue;
    }
}
function handleResultAndGetCase(value, result) {
    if (result instanceof Function) {
        return new Case(value, result(value));
    }
    return new Case(value, result);
}
function isPresent(value) {
    return value !== undefined && value !== null;
}
export default function match(value) {
    return new Case(value);
}
