type Fn<T> = (arg: T) => unknown;
declare class Case<T, P = any> {
    private value;
    private result;
    constructor(value: T, result?: unknown | null);
    case<U>(compareValue: T, result: Fn<U & T> | U): Case<T, P>;
    default<D>(defaultValue?: D): any;
}
export default function match<T>(value: T): Case<T, T>;
export {};
